#include <windows.h>
#include <winsock.h>
#include <stdio.h>
#include <string.h>
void ping(char *indi);

void main(int argc, char **argv)
{
	ping("www.spappolatori.com");
	ping("www.spippolatori.com");
	ping("www.bruzzi.com");
}

// Procedura per il Ping pronta da implementare su SUPERPORTSCAN 


void ping(char *indi)
{
	typedef struct tagIPINFO
	{
	u_char Ttl;	
	u_char Tos;	
	u_char IPFlags;	
	u_char OptSize;	
	u_char FAR *Options;	
	} IPINFO, *PIPINFO;

	typedef struct tagICMPECHO
	{
	u_long Source;	
	u_long Status;	
	u_long RTTime;	
	u_short DataSize;	
	u_short Reserved;	
	void FAR *pData;	
	IPINFO ipInfo;	
	} ICMPECHO, *PICMPECHO;

	HANDLE(WINAPI *pIcmpCreateFile)(VOID);
	BOOL(WINAPI *pIcmpCloseHandle)(HANDLE);
	DWORD(WINAPI *pIcmpSendEcho)(HANDLE, DWORD, LPVOID, WORD, PIPINFO, LPVOID, DWORD, DWORD);
				
	WSADATA wsaData;	
	ICMPECHO icmpEcho;	
	HANDLE hndlIcmp;	
	HANDLE hndlFile;	
	LPHOSTENT pHost;	
	struct in_addr iaDest;	
	DWORD *dwAddress;	
	IPINFO ipInfo;	
	int nRet;	
	DWORD dwRet;	
	int x;
	hndlIcmp = LoadLibrary("ICMP.DLL");
	pIcmpCreateFile = (HANDLE(WINAPI *)(void)) 
			  GetProcAddress(hndlIcmp, "IcmpCreateFile");
	pIcmpCloseHandle = (BOOL(WINAPI *)(HANDLE)) 
			   GetProcAddress(hndlIcmp, "IcmpCloseHandle");
	pIcmpSendEcho = (DWORD(WINAPI *)
			(HANDLE, DWORD, LPVOID, WORD, PIPINFO, LPVOID, DWORD, DWORD)) 
			GetProcAddress(hndlIcmp, "IcmpSendEcho");	
	nRet = WSAStartup(0x0101, &wsaData);
	iaDest.s_addr = inet_addr(indi);
	if (iaDest.s_addr == INADDR_NONE) pHost = gethostbyname(indi);
	else pHost = gethostbyaddr((const char *) &iaDest, sizeof(struct in_addr), AF_INET);
	if (pHost == NULL){
		printf("\n[%s] -> non trovato\n", indi);
		WSACleanup();
		FreeLibrary(hndlIcmp);
		return;}
	printf("\nPing %s -> [%s]", pHost->h_name, inet_ntoa((* (LPIN_ADDR) pHost->h_addr_list[0])));
	dwAddress = (DWORD *)(*pHost->h_addr_list);
	hndlFile = pIcmpCreateFile();
	for (x = 0; x < 4; x++){	
		ipInfo.Ttl = 255;
		ipInfo.Tos = 0;
		ipInfo.IPFlags = 0;
		ipInfo.OptSize = 0;
		ipInfo.Options = NULL;				
		dwRet = pIcmpSendEcho(hndlFile,	*dwAddress,NULL,0,&ipInfo,&icmpEcho,sizeof(struct tagICMPECHO), 5000);				
		iaDest.s_addr = icmpEcho.Source;
		printf("\nReply from %s  Time=%ldms  TTL=%d", inet_ntoa(iaDest), icmpEcho.RTTime, icmpEcho.ipInfo.Ttl);
		if (icmpEcho.Status){printf("## -> %ld", icmpEcho.Status);break;}
	}
	printf("\n");	
	pIcmpCloseHandle(hndlFile);
	FreeLibrary(hndlIcmp);
	WSACleanup();
}
